import java.awt.Color;

public class Stepper extends Turtle{
  public int n;               //󥹥ѿ n 
  public int size;      //󥹥ѿ size 
  private int j = 0;              //˥󥹥ѿ j 
  public static final int ALREADY_FIN = 0;
  public static final int JUST_FIN = 1;
  public static final int  NOT_FIN = 2;

  /** x, y Ȥɸ angle γ٤ Stepper  */
  Stepper(int x, int y, int angle, int n, int size)
    {
      super(x, y, angle);    //Turtle Υ󥹥ȥ饯ƤӽФ
      this.n = n;            //󥹥ѿ n   n 
      this.size = size;      //󥹥ѿ size 
    }

  /** n = 4, size = 100  Stepper  */
  Stepper(int x, int y, int angle)
    {
      this(x, y, angle, 4, 100); //嵭Υ󥹥ȥ饯ƤӽФ
    }

  /** 0 Υ󥹥ȥ饯 */
  Stepper() {   super();}    //̥󥹥ȥ饯ƤӽФ
  
  public int step()
  {
    if(j >= n)
        return ALREADY_FIN;         //Ƥʤ餹λ
    fd(size);
    rt(360/n);
    if(++j == n)       //j1䤹Ȥ n Ӥ뤳Ȥ1ĤμǹԤ
        return JUST_FIN;  
    return NOT_FIN;                  //Τϡ2Ĥ if ξʤȤ
  }
  public void reset() { j = 0; }

  public static void main(String[] args){
    TurtleFrame f = new TurtleFrame(600,300);
    int[] size = {100,28,90,40,2,100,40,2, 30, 20};
    int[] n = {6, 5, 3,10,20,3,4,5,3,5};
    Color[] c = {Color.black, Color.blue, Color.cyan, Color.darkGray};
    Stepper[] hm = new Stepper[10];
    for(int i = 0 ; i < 10; i++){
      hm[i] = new Stepper(i * 50 + 25,150,0, n[i], size[i]);
      hm[i].setColor(c[i % c.length]);
      f.add(hm[i]);
    }
    for(int j = 0; j < 20; j++){
      for(int i = 0; i < 10; i++){
	hm[i].step();
      }
    }
  }

}
